/* $Id: check.h,v 1.6 2002/07/26 15:48:41 peteri Exp $ */
#ifndef CHECK_H
#define CHECK_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "mesh.h"

int CheckCavity(Tos_MStack cavity, Tos_MStack newCavity); 
int CheckCoplanarity(TetrahMesh *tetMesh);
int CheckMeshConformity(TetrahMesh *tetMesh);
int CheckTetrahAdjacency(TetrahMesh *tetMesh);
int CheckSurfaceCompletness(MeshGenData *mgds);
void CheckMeshpointsFlags(TetrahMesh *tetMesh); 
int CheckAlphaParam(MeshGenData *mgds);


#ifdef __cplusplus
}
#endif

#endif /* CHECK_H */

/* Modifications:
 * $Log: check.h,v $
 * Revision 1.6  2002/07/26 15:48:41  peteri
 * - checking the alpha parameter of the Delaunay process is
 *   integrated
 *
 * Revision 1.5  2002/07/26 11:36:48  peteri
 * cavity check is extended, it checks for equal volumes as well
 *
 * Revision 1.4  2002/02/24 19:01:01  romek
 * *** empty log message ***
 *
 * Revision 1.3  2002/02/16 18:58:43  romek
 * Doc fix.
 *
 */
