/* $Id: debug.c,v 1.8 2002/07/26 11:38:22 peteri Exp $ */

#include <stdio.h>
#include "list.h"
#include "edge.h"
#include "debug.h"

/* Allows to select verbosity of the program -- see debug.h */
int vm_verbose_level = 2; 

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/****f*
 * NAME
 *  CountSplitedEdges 
 * DESCRIPTION
 *  Return number of edges which were splited by additional points.
 * ARGUMENTS
 *  mgds - pointer to mesh generator data structure.
 * RETURN VALUE
 *  Number of edes splited by recovery points.
 ******/
int CountSplitedEdges (MeshGenData *mgds)
{
  int   i, iedge, counter;
  Edge *edge;

  counter = 0;
  /* for each input mesh */
  for (i=0; i<mgds->NMeshes; i++)
  {
    for(iedge = 0; iedge < mgds->eTableLength[i]; iedge++)
    {
      edge = mgds->eTable[i][iedge];

      if(Tos_MStackCount(edge->splitEdges) > 0)
          counter++; 
    }
  }
  return counter;
} /* end of CountSplitedEdges */

/* Modifications:
 * $Log: debug.c,v $
 * Revision 1.8  2002/07/26 11:38:22  peteri
 * - nana is removed for simplicity
 * - edge stores split edges and not splitting points
 *
 * Revision 1.7  2002/02/24 19:01:02  romek
 * *** empty log message ***
 *
 * Revision 1.6  2002/02/16 18:58:46  romek
 * Doc fix.
 *
 */
