/* $Id: flip.h,v 1.5 2002/02/24 19:01:08 romek Exp $ */

#ifndef FLIP_H
#define FLIP_H

#ifdef __cplusplus
extern "C"
{
#endif


#include "mstack.h"
#include "vertex.h"
#include "tetrah.h"
#include "mesh.h"
#include "measures.h"

int SwapEdgeForOptimization(TetrahMesh *tetMesh, Vertex *v1, Vertex *v2,
                            enum MeasureType measure);
int BruteForceFlipEdges(TetrahMesh *tetMesh, enum MeasureType measure, 
                        double minMeasure, double maxMeasure,  
                        Vertex *nodeA, Vertex *nodeB,
                        Vertex *np, Vertex *sp, int N,
                        Tos_MStack equator);
int SwapNEdgeConf(TetrahMesh *tetMesh, Vertex *nodeA, Vertex *nodeB,
                  Tetrah *tetA, int *vertices);
int Swap2To3EdgeRecovery (TetrahMesh *tetMesh, Vertex *nodeA, Vertex *nodeB,
                          Tetrah *tetA, int *verticesA);
int TrySwapEdgeRecovery (TetrahMesh *tetMesh, Vertex *nodeA, Vertex *nodeB,
                         Tetrah *tetA, int intersectionType, int *vertices);


#ifdef __cplusplus
}
#endif

#endif /* FLIP_H */

/* Modifications:
 * $Log: flip.h,v $
 * Revision 1.5  2002/02/24 19:01:08  romek
 * *** empty log message ***
 *
 */
