
#ifndef MESH_OP_H
#define MESH_OP_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "vertex.h"
#include "tetrah.h"
#include "edge.h"
#include "face.h"
#include "mesh.h"


void InsertPointOnEdge (TetrahMesh *tetMesh, Vertex *point, Edge *edge);
void InsertPointOnFace (TetrahMesh *tetMesh, Vertex *point, Face *face);
void AddTetToMesh (TetrahMesh *tetMesh, Tetrah *tet);
void RemoveTetFromMesh (TetrahMesh *tetMesh, Tetrah *tet);
int SegmentTetMeshIntersect (TetrahMesh *tetMesh, Vertex *nodeA,
                            Vertex *nodeB, Tetrah **tet, int *intersectionType,
                             Vertex **intersectionPoint, int *vertices);
int IsFaceOnMeshBoundary (MeshGenData *mgds, int surfMeshNum,
                          Face *face, int boundFlag);


#ifdef __cplusplus
}
#endif

#endif /* MESH_OP_H */






