/********************************************************************
 gentriangadj.h  --
 
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University, Edinburgh    
 ********************************************************************/

/* $Id: triangadj.h,v 1.2 2002/03/18 16:00:31 peteri Exp $ */

#ifndef TRIANGADJ_H
#define TRIANGADJ_H
    
#include "e_lib.h"           

int Triang1Adjacency (MESH *mesh,
                      int *nodeElemAdjLen, int **nodeElemAdj,
                      int ***AdjElems);

#endif /* TRIANGADJ_H */

/* Modifications:
 * $Log: triangadj.h,v $
 * Revision 1.2  2002/03/18 16:00:31  peteri
 * Simplified adjacency determination.
 *
 * Revision 1.1  2002/01/31 21:27:40  peteri
 * Major reorganization in the code.
 * - It is split into smaller modules.
 * - Some types, functions are renamed
 * - Proper flipping of edges is implemented
 *
 * Revision 1.1.1.1  2002/01/30 10:20:55  peteri
 * Imported using TkCVS
 *
 * Revision 1.1  2001/07/14 17:42:17  romek
 * Initial revision
 *
 * Revision 1.3  2000/02/12 14:44:12  romek
 * typos corrections
 *
 * Revision 1.2  2000/02/09 13:29:25  romek
 * Tos_Triang1Adjacency and Tos_FreeTriang1Adjacency added
 *
 * Revision 1.1  2000/02/08 19:08:49  romek
 * Initial revision
 *
 */ 
