/********************************************************************
 nodelem.c -- 
        This file implements function to biuld nodes:->elements
        adjacency lists. 
 
 The function e_InitMeshPointElemConnection is to curtuasy of 
 Peter Ivanyi.

 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University, Edinburgh    
 ********************************************************************/

/* $Id: nodelem.c,v 1.1 2002/07/26 19:36:20 romek Exp romek $ */

#include "nodelem.h"

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 e_InitMeshPointElemConnection --
 
        Build nodes->elements adjacency. 

 Author:  Peter Ivanyi.      
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void e_InitMeshPointElemConnection(MESH *mesh,
                                   int *no_node_elem,
                                   int **node_elem)
{
  int i,j,n;

  for(i = 0; i < mesh->NElemsLink1; i++)
  {
    for(j = 0; j < 2; j++)
    {
      n = mesh->NodesLink1[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_LINK1];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsLink2; i++)
  {
    for(j = 0; j < 2; j++)
    {
      n = mesh->NodesLink2[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_LINK2];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsLink3; i++)
  {
    for(j = 0; j < 2; j++)
    {
      n = mesh->NodesLink3[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_LINK3];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsLink4; i++)
  {
    for(j = 0; j < 2; j++)
    {
      n = mesh->NodesLink4[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_LINK4];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsLink5; i++)
  {
    for(j = 0; j < 2; j++)
    {
      n = mesh->NodesLink5[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_LINK5];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsTriang1; i++)
  {
    for(j = 0; j < 3; j++)
    {
      n = mesh->NodesTriang1[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG1];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsTriang3; i++)
  {
    for(j = 0; j < 3; j++)
    {
      n = mesh->NodesTriang3[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG3];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsTriang4; i++)
  {
    for(j = 0; j < 3; j++)
    {
      n = mesh->NodesTriang4[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG4];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsTriang5; i++)
  {
    for(j = 0; j < 3; j++)
    {
      n = mesh->NodesTriang5[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG5];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsQuad1; i++)
  {
    for(j = 0; j < 4; j++)
    {
      n = mesh->NodesQuad1[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_QUAD1];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsQuad3; i++)
  {
    for(j = 0; j < 4; j++)
    {
      n = mesh->NodesQuad3[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_QUAD3];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsTetrah1; i++)
  {
    for(j = 0; j < 4; j++)
    {
      n = mesh->NodesTetrah1[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_TETRAH1];
      no_node_elem[n]++;
    }
  }

  for(i = 0; i < mesh->NElemsBlock1; i++)
  {
    for(j = 0; j < 8; j++)
    {
      n = mesh->NodesBlock1[i][j] - 1;
      node_elem[n] = e_incr_i_vect(no_node_elem[n], node_elem[n], 1);
      node_elem[n][no_node_elem[n]] = 
        i + mesh->FirstNetIndex[E_ELEM_TYPE_BLOCK1];
      no_node_elem[n]++;
    }
  }


}


/* Modifications:
 * $Log: nodelem.c,v $
 * Revision 1.1  2002/07/26 19:36:20  romek
 * Initial revision
 *
 * Revision 1.2  2002/01/31 21:27:56  peteri
 * Major reorganization in the code.
 * - It is split into smaller modules.
 * - Some types, functions are renamed
 * - Proper flipping of edges is implemented
 *
 * Revision 1.1.1.1  2002/01/30 10:20:56  peteri
 * Imported using TkCVS
 *
 * Revision 1.1  2001/07/14 17:42:44  romek
 * Initial revision
 *
 */ 
            
