#include "e_lib.h"
#include "common.h"

#define TOLERANCE  1e-8

double ScalarProd(double x1, double y1, double x2, double y2,
                  double x3, double y3, double x4, double y4)
{
  double dx1, dy1, dx2, dy2, dl1, dl2, s;

  dx1 = x1 - x2;
  dy1 = y1 - y2;
  
  dx2 = x3 - x4;
  dy2 = y3 - y4;
  
  dl1 = sqrt((dx1*dx1) + (dy1*dy1));
  dl2 = sqrt((dx2*dx2) + (dy2*dy2));

  if(dl1 < TOLERANCE || dl2 < TOLERANCE)
  {
    e_GeneralError("ScalarProd: internal error");
  }

  s = E_ABS((dx1 / dl1) * (dx2 / dl2) + (dy1 / dl1) * (dy2 / dl2));

  return(s);
}


