/********************************************************************
 gentriangadj.h  --
 
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University, Edinburgh    
 ********************************************************************/

/* $Id: gentriangadj.h,v 1.1.1.1 2001/04/09 22:50:37 peteri Exp $ */

#ifndef GENTRIANGADJ_H
#define GENTRIANGADJ_H
    
#include "e_lib.h"           

#define E_COMP_ADJ   0   /* beahvoiour compatibile with e_SetAdjacency */
#define TOS_COMP_ADJ 1   /* can be used for generally
                          * connected Trianh1 meshes
                          */

/* Tos_Triang1ElemsAdjToSide -- build list of elements adjacent to a side */
int Tos_Triang1ElemsAdjToSide (MESH *mesh, int elem, int side, 
               int *nodeElemAdjLen, int **nodeElemAdj, int **sideAdj);

/* Tos_GenTriang1Adj -- generalized adjacency for Triang1 elements */
int Tos_GenTriang1Adj (MESH *mesh, char flag, int **Degree,
                int ***AdjElems);

void Tos_FreeGenTriang1Adj (MESH *mesh, int *Degree, int **AdjElems);

#endif /* GENTRIANGADJ_H */

/* Modifications:
 * $Log: gentriangadj.h,v $
 * Revision 1.1.1.1  2001/04/09 22:50:37  peteri
 * Imported using TkCVS
 *
 * Revision 1.1  2000/02/08 19:08:49  romek
 * Initial revision
 *
 */ 
