#ifndef MGN_H__
#define MGN_H__

#include "config.h"
#include "mgni.h"
#include "bgdata.h"
#include "mtrf.h"

/* global variables */
#ifndef MGNI_C
#define XKW	extern
#else
#define XKW
#endif
XKW int DebugOutput;            /* debug output active */
XKW int ShowGraphics;           /* graphics enabled */
XKW int PrintProgress;          /* print progress statements */
#undef XKW

/* macro defined constants */
#define INCR_SIZE   10          /* initial memory allocation for incrementally
                                   allocated variables; must be at least 4 */

/* mgn functions */
void show_usage(void);
void get_cmdline_options(int argc, char **argv);
int load_check_crsmesh(MGNI *mgni, MESH ** mesh);
void parse_meshsize_ctrl(MGNI *mgni, BG_DATA **bgd, double **crsmpr);
int parse_mgn_into_mgni(MGNI **mgni, char *filename);

/* adv front functions */
void adv_main(MGNI *mgni);

/* paving functions */
void pav_main(MGNI *mgni);

/* dtr functions */
void dtr_main(MGNI *mgni);

/* rgr functions */
void rgr_main(MGNI *mgni);

#endif
