#ifndef MGN_GRAPHICS_H
#define MGN_GRAPHICS_H

#include <time.h>
#include <stdio.h>
#include <math.h>

#include "config.h"

#ifdef HAVE_LIBG2
#include "g2.h"

#ifdef WIN32
#include "g2_win32.h"
#else
#include "g2_X11.h"
/* #include "g2_GIF.h" */
#endif

#endif /* HAVE_LIBG2 */

#define   G2_WINDOW_X     600
#define   G2_WINDOW_Y     600

#define   G2_MARGIN       0.2

#define   G2_INTERRUPT    1
#define   G2_DRAW_ETEXT   2
#define   G2_DRAW_NTEXT   4
#define   G2_DRAW_NODE    8
#define   G2_DRAW_TITLE   16
#define   G2_FILL_ELEM    32
#define   G2_OUTLINE_ELEM 64

#ifdef MAIN_MGN_GRAPHICS
int mgn_g2Step = 0;
int mgn_g2Device;
double mgn_g2PointSize;
#else
extern int mgn_g2Step;
extern int mgn_g2Device;
extern double mgn_g2PointSize;
#endif


#ifdef HAVE_LIBG2
void MeshToScreen(double x, double y, double *nx, double *ny);

void mgnInitGraphics(int w, int h, int NNodes, double **Coords);
void mgnCloseGraphics(void);
void mgnClearGraphics(void);


void mgnDrawNumber(double x, double y, int n, double offset);
void mgnDrawNode(double x, double y, int n, int op);
void mgnDrawAllNode(int NCoord, double **Coords, int op);
void mgnDrawQuad(double **coords, int *nodes, int n, int op, int index);
void mgnDrawAllQuad(double **coords, int **nodes, int n, int op, int index);
void mgnDrawTriang(double **coords, int *nodes, int n, int op, int index);
void mgnDrawAllTriang(double **coords, int **nodes, int n, int op, int index);

/* void mgnDrawLoop(double **coords, LOOP *loop, int op); */

void mgnDrawAll(int NNodes, double **NodeCoords,
                int NTriang, int **NodesTriang,
                int NQuad, int **NodesQuad, int index,
                void (*mgnExtDraw) (), void *data, char *Title);

#else

#define MeshToScreen(x, y, nx, ny) /* empty */
#define mgnInitGraphics(w, h, NNodes, Coords) /* empty */
#define mgnCloseGraphics() /* empty */
#define mgnClearGraphics() /* empty */

#define mgnDrawNumber(x, y, n, offset) /* empty */
#define mgnDrawNode(x, y, n, op) /* empty */
#define mgnDrawAllNode(NCoord, Coords, op) /* empty */
#define mgnDrawQuad(coords, nodes, n, op, index) /* empty */
#define mgnDrawAllQuad(coords, nodes, n, op, index) /* empty */
#define mgnDrawTriang(coords, nodes, n, op, index) /* empty */
#define mgnDrawAllTriang(coords, nodes, n, op, index) /* empty */


#define mgnDrawAll(NNodes, NodeCoords, NTriang, NodesTriang, \
                   NQuad, NodesQuad, index, \
                   mgnExtDraw, data, Title) /* empty */

#endif /* HAVE_LIBG2 */


#endif
