#include "pav_graphics.h"

#ifdef HAVE_LIBG2

static void DrawLoop(double **coords, LOOP *loop, int op)
{
  NODE  *curr, *start;
  double x, y;
  int    n;
  double nx, ny;

  if(loop->Nodes == NULL)
    return;

  curr = start = loop->Nodes;
  g2_pen(mgn_g2Device, 0);
  MeshToScreen(coords[start->Node][0], coords[start->Node][1], &nx, &ny);

  g2_move(mgn_g2Device, nx, ny);

  do
  {
    curr = curr->Next;
    n = curr->Node;
    x = coords[n][0];
    y = coords[n][1];
    MeshToScreen(x, y, &nx, &ny);

    g2_line_to(mgn_g2Device, nx, ny);

  }
  while(curr != start);

  /* mark loop head */

  g2_pen(mgn_g2Device, 19);
  n = loop->Nodes->Node;
  x = coords[n][0];
  y = coords[n][1];
  MeshToScreen(x, y, &nx, &ny);

  g2_filled_circle(mgn_g2Device, nx, ny, mgn_g2PointSize);
}



void mgnDrawAllLoops(int NNodes, double **NodeCoords, 
                     int NTriang, int **NodesTriang,
                     int NQuad, int **NodesQuad, int index,
                     void *data, int op)
{
  LOOP *loop, *start;

  start = loop = (LOOP *)data;
  if(loop != NULL)
  {
    do
    {
      DrawLoop(NodeCoords, loop, op);
      loop = loop->Next;
    }
    while(loop != start);
  }

}

#endif


