#include "pav_main.h"

MESH *ConvertToMesh(PAVEDMESH *pm)
{
  MESH *m;
  int   n, i, j;
  int  *trans;

  trans = e_alloc_i_vect(pm->NNodes);
 
  m = e_calloc(1, sizeof(MESH));
  m->Title = e_alloc_c_vect(1);
  m->Title[0] = '\0';
  m->KeywordSet[E_KW_NUM_TITLE] = TRUE;

  n = 0;
  for(i = 0; i < pm->NNodes; i++)
  {
#ifndef PAVING_DEBUG
    if(pm->NNodeElem[i] > 0)
#endif
      n++;
  }

  m->NMeshPoints = n;
  m->KeywordSet[E_KW_NUM_NMESHPOINTS] = TRUE;
  m->NNodes = n;
  m->KeywordSet[E_KW_NUM_NNODES] = TRUE;

  m->NElemsQuad1 = pm->NQuads;
  m->KeywordSet[E_KW_NUM_NELEMS_QUAD1] = TRUE;
  m->FirstNetIndex[E_ELEM_TYPE_QUAD1] = 1;
  

  m->TotalNElems = pm->NQuads;

  m->MeshPointCoords = e_alloc_cont_d_matr(n, 3);
  n = 0;
  for(i = 0; i < pm->NNodes; i++)
  {
#ifndef PAVING_DEBUG
    if(pm->NNodeElem[i] > 0)
#endif
    {
      m->MeshPointCoords[n][0] = pm->NodeCoords[i][0];
      m->MeshPointCoords[n][1] = pm->NodeCoords[i][1];
      n++;
      /* store the translation of the nodes */
      trans[i] = n;
    }
  }
  m->KeywordSet[E_KW_NUM_MESHPOINT_COORDS] = TRUE;

  m->NodesQuad1 = e_alloc_cont_i_matr(pm->NQuads, E_NVPE_QUAD1);
  for(i = 0; i < pm->NQuads; i++)
  {
    for(j = 0; j < 4; j++)
    {
      m->NodesQuad1[i][j] = trans[pm->QuadNodes[i][j]];
    }
  }

  m->KeywordSet[E_KW_NUM_NODES_QUAD1] = TRUE;

  /* final adjustments to the mesh */
  m->TotalNodalDOF = m->NMeshPoints * E_VERTEX_NODE_DOF_TRIANG1;
  m->NodalDOF = e_alloc_i_vect(m->TotalNodalDOF);
  m->GNIs = e_alloc_i_vect(m->NMeshPoints);
  for(i = 0; i < m->NMeshPoints; i++)
  {
    m->NodalDOF[i] = E_VERTEX_NODE_DOF_QUAD1;
    m->GNIs[i] = i+1;
  }
  m->GEIs = e_alloc_i_vect(m->TotalNElems);
  for(i = 0; i < m->TotalNElems; i++)
  {
    m->GEIs[i] = i+1;
  }
  m->GEIsQuad1 = m->GEIs;

  return(m);
}


